<template>
  <div class="text-right">
    <v-dialog v-model="dialog" persistent height="auto" width="1100">
      <template v-slot:activator="{ on, attrs }">
        <v-btn
          class="
            button-text
            v-btn v-btn--outlined v-btn--rounded
            theme--light
            v-size--default
            tway-violet--text
          "
          color="coral lighten-2"
          outlined
          v-bind="attrs"
          v-on="on"
        >
          <v-icon color="purple"> mdi-cog-outline </v-icon>
          CONFIGURACIÓN
        </v-btn>
      </template>
      <v-card :class="'modalSystem'">
        <v-card>
          <div class="container">
            <h3 class="text-center">CONFIGURACIÓN PLANIFICACIÓN</h3>
            <v-btn icon right @click="dialog = false" class="float-right">
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <v-card elevation="1" shaped>
              <v-card-title>{{ setup.name }} ( {{ setup.code }} )</v-card-title>
              <v-card-text>
                <v-row align="center" class="mx-0">
                  <div class="my-2 text-subtitle-1">
                    La fecha propuesta comienza el
                    {{ setup.humanStartDateProposal }} y términa el
                    {{ setup.humanEndDateProposal }}
                  </div>
                </v-row>
              </v-card-text>
            </v-card>
            <form>
              <div class="d-flex justify-space-between mt-5">
                <v-row>
                  <v-col md="6">
                    <v-menu
                      v-model="menu"
                      :close-on-content-click="false"
                      :nudge-right="40"
                      transition="scale-transition"
                      offset-y
                      min-width="auto"
                    >
                      <template v-slot:activator="{ on, attrs }">
                        <v-text-field
                          v-model="startDateProposal"
                          label="Fecha Término"
                          prepend-icon="mdi-calendar"
                          readonly
                          outlined
                          v-bind="attrs"
                          v-on="on"
                        ></v-text-field>
                      </template>
                      <v-date-picker
                        v-model="startDateProposal"
                        @input="menu = false"
                      ></v-date-picker>
                    </v-menu>
                  </v-col>
                  <v-col md="6">
                    <v-menu
                      v-model="menu2"
                      :close-on-content-click="false"
                      :nudge-right="40"
                      transition="scale-transition"
                      offset-y
                      min-width="auto"
                      :min="startDateProposal"
                    >
                      <template v-slot:activator="{ on, attrs }">
                        <v-text-field
                          v-model="endDateProposal"
                          label="Fecha Término"
                          prepend-icon="mdi-calendar"
                          readonly
                          outlined
                          v-bind="attrs"
                          v-on="on"
                          :min="startDateProposal"
                        ></v-text-field>
                      </template>
                      <v-date-picker
                        v-model="endDateProposal"
                        @input="menu2 = false"
                        :min="startDateProposal"
                      ></v-date-picker>
                    </v-menu>
                  </v-col>
                  <v-col
                    md="12"
                    class="text-center d-flex justify-center pa-md-5 mx-lg-auto"
                  >
                    <v-btn
                      outlined
                      color="indigo lighten-2"
                      class="
                        button-text
                        v-btn v-btn--outlined v-btn--rounded
                        theme--light
                        v-size--default
                        tway-violet--text
                      "
                      @click.stop="saveProject"
                    >
                      <div v-if="!loading.saveProject">
                        <v-icon color="purple"> mdi-content-save </v-icon>
                        Guardar Proyecto
                      </div>
                      <div v-else>Loding....</div>
                    </v-btn>
                  </v-col>
                </v-row>
              </div>
            </form>
            <!-- ETAPAS -->
            <form>
              <div class="d-flex justify-space-around mx-6 mt-1">
                <div class="row">
                  <div class="col-12 mt-8">
                    Etapas
                    <v-divider class="divisor"></v-divider>
                  </div>
                  <div class="col-4">
                    <v-text-field
                      label="Etapa"
                      type="text"
                      v-model="stage.name"
                      outlined
                    />
                  </div>
                  <div class="col-4">
                    <!-- Fecha Inicio Etapa -->
                    <v-menu
                      v-model="menu3"
                      :close-on-content-click="false"
                      :nudge-right="40"
                      transition="scale-transition"
                      offset-y
                      min-width="auto"
                    >
                      <template v-slot:activator="{ on, attrs }">
                        <v-text-field
                          v-model="stage.dateStart"
                          label="Fecha Inicio"
                          prepend-icon="mdi-calendar"
                          readonly
                          outlined
                          v-bind="attrs"
                          v-on="on"
                        ></v-text-field>
                      </template>
                      <v-date-picker
                        v-model="stage.dateStart"
                        @input="menu3 = false"
                      ></v-date-picker>
                    </v-menu>
                  </div>
                  <div class="col-4">
                    <!-- Fecha de Termino Etapa -->
                    <v-menu
                      v-model="menu4"
                      :close-on-content-click="false"
                      :nudge-right="40"
                      transition="scale-transition"
                      offset-y
                      min-width="auto"
                      :min="stage.dateStart"
                    >
                      <template v-slot:activator="{ on, attrs }">
                        <v-text-field
                          v-model="stage.dateEnd"
                          label="Fecha Término"
                          prepend-icon="mdi-calendar"
                          readonly
                          outlined
                          v-bind="attrs"
                          v-on="on"
                          :min="stage.dateStart"
                        ></v-text-field>
                      </template>
                      <v-date-picker
                        v-model="stage.dateEnd"
                        @input="menu4 = false"
                        :min="stage.dateStart"
                      ></v-date-picker>
                    </v-menu>
                  </div>
                  <div
                    class="
                      col-12
                      text-center
                      d-flex
                      justify-center
                      pa-md-5
                      mx-lg-auto
                    "
                  >
                    <v-btn
                      outlined
                      color="indigo lighten-2"
                      class="
                        button-text
                        v-btn v-btn--outlined v-btn--rounded
                        theme--light
                        v-size--default
                        tway-violet--text
                      "
                      @click.stop="saveStage"
                    >
                      <div v-if="!loading.saveStage">
                        <v-icon color="purple"> mdi-content-save </v-icon>
                        Guardar Etapa
                      </div>
                      <div v-else>Loding....</div>
                    </v-btn>
                  </div>
                </div>
              </div>
            </form>
            <!-- TABLA ETAPA -->
            <v-alert
              v-model="alert.saveStage"
              border="right"
              colored-border
              type="error"
              elevation="2"
              class="ml-2 mr-2"
            >
              {{ messageError.saveStage }}
            </v-alert>
            <v-simple-table class="table mt-5">
              <template>
                <thead>
                  <tr>
                    <th class="text-left" scope="col">#No</th>
                    <th class="text-left" scope="col">Etapa</th>
                    <th class="text-left" scope="col">Inicio</th>
                    <th class="text-left" scope="col">Término</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="(entry, i) in etapas" :key="i">
                    <th scope="row">{{ entry.id }}</th>
                    <td>{{ entry.etapa }}</td>
                    <td>{{ entry.inicio }}</td>
                    <td>{{ entry.termino }}</td>
                    <td>
                      <v-icon small color="error" @click="deleteStage(entry)">
                        delete
                      </v-icon>
                    </td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
            <!-- ACTIVIDADES -->
            <form>
              <div class="d-flex mt-4 justify-start">
                <div class="row">
                  <div class="col-12 mt-8">
                    Actividades
                    <v-divider class="divisor"></v-divider>
                  </div>
                  <div class="col-6">
                    <v-select
                      :items="combos.selectEtapas"
                      item-value="id"
                      item-text="etapa"
                      label="Etapa"
                      v-model="activity.stageSelected"
                      outlined
                    ></v-select>
                  </div>
                  <div class="col-6">
                    <v-select
                      :items="combos.responsible"
                      item-value="id"
                      item-text="nombre"
                      label="Responsable"
                      v-model="activity.responsableSelected"
                      outlined
                    ></v-select>
                  </div>
                </div>
              </div>
              <div class="d-flex justify-space-around">
                <div class="row">
                  <div class="col-4">
                    <v-text-field
                      type="text"
                      label="Actividad"
                      v-model="activity.name"
                      outlined
                    />
                  </div>
                  <div class="col-4">
                    <v-menu
                      v-model="menu5"
                      :close-on-content-click="false"
                      :nudge-right="40"
                      transition="scale-transition"
                      offset-y
                      min-width="auto"
                    >
                      <template v-slot:activator="{ on, attrs }">
                        <v-text-field
                          v-model="activity.dateStart"
                          label="Fecha Inicio"
                          prepend-icon="mdi-calendar"
                          readonly
                          outlined
                          v-bind="attrs"
                          v-on="on"
                        ></v-text-field>
                      </template>
                      <v-date-picker
                        v-model="activity.dateStart"
                        @input="menu5 = false"
                      ></v-date-picker>
                    </v-menu>
                  </div>
                  <div class="col-4">
                    <v-menu
                      v-model="menu6"
                      :close-on-content-click="false"
                      :nudge-right="40"
                      transition="scale-transition"
                      offset-y
                      min-width="auto"
                      :min="activity.dateStart"
                    >
                      <template v-slot:activator="{ on, attrs }">
                        <v-text-field
                          v-model="activity.dateEnd"
                          label="Fecha Término"
                          prepend-icon="mdi-calendar"
                          readonly
                          outlined
                          v-bind="attrs"
                          v-on="on"
                          :min="activity.dateStart"
                        ></v-text-field>
                      </template>
                      <v-date-picker
                        v-model="activity.dateEnd"
                        @input="menu6 = false"
                        :min="activity.dateStart"
                      ></v-date-picker>
                    </v-menu>
                  </div>
                  <div
                    class="
                      col-12
                      text-center
                      d-flex
                      justify-center
                      pa-md-5
                      mx-lg-auto
                    "
                  >
                    <v-btn
                      outlined
                      color="indigo lighten-2"
                      class="
                        button-text
                        v-btn v-btn--outlined v-btn--rounded
                        theme--light
                        v-size--default
                        tway-violet--text
                      "
                      @click.stop="saveActivity"
                    >
                      <div v-if="!loading.saveActivity">
                        <v-icon color="purple"> mdi-content-save </v-icon>
                        Guardar Actividad
                      </div>
                      <div v-else>Loding....</div>
                    </v-btn>
                  </div>
                </div>
              </div>
            </form>
            <!-- Tabla Actividad -->

            <v-alert
              v-model="alert.saveActivity"
              border="right"
              colored-border
              type="error"
              elevation="2"
              class="ml-2 mr-2"
            >
              {{ messageError.saveActivity }}
            </v-alert>
            <v-simple-table class="table mt-5">
              <template>
                <thead>
                  <tr>
                    <th class="text-left" scope="col">#No</th>
                    <th class="text-left" scope="col">Etapa</th>
                    <th class="text-left" scope="col">Actividad</th>
                    <th class="text-left" scope="col">Inicio</th>
                    <th class="text-left" scope="col">Término</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="(entry, i) in activities" :key="i">
                    <td>{{ entry.id }}</td>
                    <td>{{ entry.etapaId }}</td>
                    <td>{{ entry.nombre }}</td>
                    <td>{{ entry.inicio }}</td>
                    <td>{{ entry.termino }}</td>
                    <td>
                      <v-icon
                        small
                        color="error"
                        @click="deleteActivity(entry)"
                      >
                        delete
                      </v-icon>
                    </td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
            <div class="d-flex mt-12 justify-space-around">
              <div class="row">
                <div
                  class="col-12 text-center justify-center pa-md-5 mx-lg-auto"
                >
                  <v-spacer></v-spacer>
                  <v-btn
                    outlined
                    color="indigo lighten-2"
                    class="
                      button-text
                      v-btn v-btn--outlined v-btn--rounded
                      theme--light
                      v-size--default
                      tway-violet--text
                      mx-lg-auto
                    "
                    @click="closeConfigurationDialog()"
                  >
                    Actualizar y Cerrar
                  </v-btn>
                </div>
              </div>
            </div>
          </div>
        </v-card>
      </v-card>
    </v-dialog>
    <confirmation
      ref="confirm"
      :message="dialogMessage.title"
      :message-body="dialogMessage.body"
    ></confirmation>
  </div>
</template>

<script>
import BudgetService from "@/services/pmo/budget/budgetService";
import PlanificationService from "@/services/pmo/planification/planificationService";
import Confirmation from "../utils/ConfirmationDialog.vue";

export default {
  components: { Confirmation },
  data: (vm) => {
    return {
      on: false,
      dialogMessage: {
        title: "",
        body: "",
      },
      dateFormatted: vm.formatDate(
        new Date(Date.now() - new Date().getTimezoneOffset() * 60000)
          .toISOString()
          .substr(0, 10)
      ),
      loading: {
        saveStage: false,
        saveActivity: false,
      },
      alert: {
        saveStage: false,
        saveActivity: false,
      },
      messageError: {
        saveStage: "",
        saveActivity: "",
      },
      activity: {
        stageSelected: 0,
        name: "",
        dateStart: "",
        dateEnd: "",
        responsableSelected: 0,
      },
      stage: {
        name: "",
        dateStart: "",
        dateEnd: "",
      },
      dialog: false,
      menu: false,
      modal: false,
      menu1: false,
      menu2: false,
      menu3: false,
      menu4: false,
      menu5: false,
      startDateProposal: "",
      endDateProposal: "",
      etapas: [],
      combos: {
        selectEtapas: [],
        responsible: [],
      },
      setup: null,
      activities: [],
    };
  },
  watch: {
    date() {
      this.dateFormatted = this.formatDate(this.date);
    },
  },
  computed: {
    sortedList: function () {
      return this.allScores.slice().sort(function (a, b) {
        return b.score - a.score;
      });
    },
    sortedList2: function () {
      return this.allScor.slice().sort(function (a, b) {
        return b.score - a.score;
      });
    },
    computedStartDateProposal() {
      return this.formatDate(this.setup.startDateProposal);
    },
    computedStageDateStart() {
      return this.formatDate(this.stage.dateStart);
    },
    computedStageDateEnd() {
      return this.formatDate(this.stage.dateEnd);
    },
    computedDateFormatted5() {
      return this.formatDate(this.activity.dateStart);
    },
    computedDateFormatted6() {
      return this.formatDate(this.activity.dateEnd);
    },
    computedEndDateProposal(val) {
      return val;
    },
  },
  methods: {
    closeConfigurationDialog() {
      this.dialog = false;
      this.$emit("reloadPlanificationCharts");
    },
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.split("-");
      return `${day}/${month}/${year}`;
    },
    saveProject() {},
    saveStage() {
      let test = {
        proyectoId: this.setup.id,
        orden: 2,
        nombre: "Bob",
        etapa: this.stage.name,
        inicio: this.formatDate(this.stage.dateStart),
        termino: this.formatDate(this.stage.dateEnd),
      };

      this.loading.saveStage = true;

      PlanificationService.saveStage(test)
        .then(() => {
          BudgetService.stages()
            .then((data) => {
              this.etapas = data;
            })
            .catch((err) => console.dir(err));

          BudgetService.stagesInExistence()
            .then((data) => {
              this.combos.selectEtapas = data;
            })
            .catch((err) => console.dir(err));
        })
        .catch((err) => {
          let message = err.response.data.message;
          this.alert.saveStage = true;
          this.messageError.saveStage = message;
          console.dir(err);
        })
        .finally(() => {
          this.loading.saveStage = false;
          setTimeout(() => (this.alert.saveStage = false), 4000);
          this.clearForm();
        });
    },
    saveActivity() {
      let test = {
        proyectoId: this.setup.id,
        orden: 2,
        nombre: this.activity.name,
        etapaId: this.activity.stageSelected,
        responsableId: this.activity.responsableSelected,
        inicio: this.activity.dateStart,
        termino: this.activity.dateEnd,
      };

      this.loading.saveActivity = true;

      PlanificationService.saveActivity(test)
        .then(() => {
          PlanificationService.getActivities()
            .then((data) => {
              console.dir(data);
              this.activities = data;
            })
            .catch((err) => console.dir(err));
        })
        .catch((err) => {
          let message = err.response.data.message;
          this.alert.saveActivity = true;
          this.messageError.saveActivity = message;
          console.dir(err);
        })
        .finally(() => {
          this.loading.saveActivity = false;
          setTimeout(() => (this.alert.saveActivity = false), 4000);
          this.clearForm();
        });
    },
    clearForm() {},
    deleteStage(entry) {
      this.dialogMessage.title = "¿Está seguro de eliminar esta etapa?";
      this.dialogMessage.body =
        "Esta acción eliminará todas las actividades asociadas a esta etapa";
      console.dir(this.$refs);

      const veamos = this.$refs.confirm.open();

      veamos.then(() => {
        PlanificationService.deleteStage(entry.id)
          .then(() => {
            PlanificationService.stages()
              .then((data) => {
                this.etapas = data;
              })
              .catch((err) => console.dir(err));

            PlanificationService.stagesInExistence()
              .then((data) => {
                this.combos.selectEtapas = data;
              })
              .catch((err) => console.dir(err));
          })
          .catch((err) => console.dir(err))
          .finally(() => {});
      });
    },
    deleteActivity(entry) {
      PlanificationService.deleteActivity(entry.id)
        .then(() => {
          PlanificationService.getActivities()
            .then((data) => {
              this.activities = data;
            })
            .catch((err) => console.dir(err));
        })
        .catch((err) => console.dir(err));
    },
  },
  mounted() {
    this.clearForm();

    PlanificationService.setup()
      .then((data) => {
        console.dir(data);
        this.setup = data;
      })
      .catch((err) => console.dir(err));

    PlanificationService.getActivities()
      .then((data) => {
        console.dir(data);
        this.activities = data;
      })
      .catch((err) => console.dir(err));

    BudgetService.stages()
      .then((data) => {
        this.etapas = data;
      })
      .catch((err) => console.dir(err));

    PlanificationService.stagesInExistence()
      .then((data) => {
        this.combos.selectEtapas = data;
      })
      .catch((err) => console.dir(err));

    PlanificationService.getResponsible()
      .then((data) => {
        this.combos.responsible = data;
      })
      .catch((err) => console.dir(err));
  },
};
</script>

<style>
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}
.modalSystem {
  border-radius: 0px !important;
}
.v-menu__content.theme--light.v-menu__content--fixed.menuable__content__active {
  background-color: #fff;
}
.modalSystem .v-card.v-sheet.theme--light {
  padding: 20px 40px;
}
.modalSystem label.v-label.theme--light,
.edit_row .v-text-field__details {
  font-family: "Josefin Sans", sans-serif !important;
}
.modalSystem fieldset {
  border-color: #4a148c !important;
}
.modalSystem label.v-label--active {
  color: #4a148c !important;
}
.modalSystem button.v-btn.primary {
  background-color: #4a148c !important;
  border-color: #4a148c !important;
}
.edit_row .v-input__slot,
.edit_row .v-select {
  min-height: 35px !important;
  max-height: 35px !important;
  margin-bottom: 0px !important;
}
.edit_row .v-text-field--outlined .v-label {
  top: 8px;
  font-size: 13px !important;
}
.edit_row .v-input__append-inner {
  margin-top: 5px !important;
}
.edit_row .v-text-field__details {
  display: none;
}
.edit_row .v-select__selection,
.edit_row .v-text-field__slot input {
  font-size: 0.875rem;
}
.edit_row label.v-label.v-label--active.theme--light {
  top: 18px;
}
tr.edit_row td {
  height: 60px !important;
}
.modalSystem .edit_row fieldset {
  border-color: #fff !important;
  background-color: #f2f2f2;
}
.modalSystem .v-data-table__wrapper {
  max-height: 408px;
  overflow: auto;
}
.modalSystem .edit_row.is-visible fieldset {
  border-color: transparent !important;
  background-color: transparent;
}
.modalSystem button.float-right {
  z-index: 9;
  top: 15px;
  right: 15px;
  position: absolute;
}
.modalSystem hr.divisor.v-divider.theme--light {
  width: calc(100% - 100px);
  float: right;
  margin-top: 13px;
}
.peso {
  float: left;
  margin-right: 5px;
  top: 7px;
  position: relative;
}
tr.edit_row td .edit {
  display: none;
}
tr.edit_row.is-visible td {
  pointer-events: none;
}
tr.edit_row.is-visible td.buttons {
  pointer-events: visible;
}
tr.edit_row.is-visible td .save {
  display: none !important;
}
tr.edit_row.is-visible td .edit {
  display: inline-grid !important;
}
tr.edit_row.is-visible .v-input__append-inner {
  display: none !important;
}
tr.edit_row.is-visible label.v-label.v-label--active.theme--light {
  display: none;
}
</style>
